## Bash git prompt for Ubuntu desktop 22.04 and 24.04

This is a bash git prompt with theme support that displays usefull information about the current git repository.

This prompt is a fork of magicmonty git prompt located [\[here\]](https://github.com/magicmonty/bash-git-prompt) which again is a port of this one located [\[here\]](https://github.com/olivierverdier/zsh-git-prompt) I suspect none of the ports are maintained anlylonger and this is why I decided to fork it. Besides a few changes to the original port new themes has been created and some themes has been removed.

### Prompt Structure.
The default "Out Of The Box" theme appearance of the prompt looks like this. I removed the time stamp from the default theme btw. 

```plaintext
<last status><working dir><branch><upstream branch>|<branch tracking>
```

### And it looks like this with the default theme.
<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-default.png" alt="default theme"/>
</p>

### Theme symbols used with the default theme.

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-default-symbols.png" alt="default symbols"/>
</p>

### Theme symbols used with the additional themes provided requires DejaVuSansMono Nerd Font Mono to be present. 

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-extended-symbols.png" alt="extended symbols"/>
</p>

### Install via git clone
```
git clone https://git.x-files.dk/ubuntu-desktop/bash-git-prompt.git ~/.bash-git-prompt
```

### Install the required fonts needed for all other themes exept the deafault theme.
```bash
cd ~/.bash-git-prompt
./install-fonts.sh
```

### Next set your terminal to use the DejaVuSansMono Nerd Font Mono as shown below.

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-terminal.png" alt="Terminal font settings"/>
</p>

### Getting everything up and running.

**Important:** Remove all references for other git prompts you may have running. Then add the following to your ~/.bashrc file.
```bash
if [ -f "$HOME/.bash-git-prompt/gitprompt.sh" ]; then
    GIT_PROMPT_THEME=default
    alias gpchange="bash $HOME/.bash-git-prompt/gpchange.sh"
    alias gpthemes="bash $HOME/.bash-git-prompt/gpthemes.sh"
    source "$HOME/.bash-git-prompt/gitprompt.sh"
fi
```

### Changing themes method 1
Edit your ~/.bashrc file and change the line GIT_PROMPT_THEME=theme with another theme. For example to change the default theme to something else change.

```bash
if [ -f "$HOME/.bash-git-prompt/gitprompt.sh" ]; then
    GIT_PROMPT_THEME=default
    alias gpchange="bash $HOME/.bash-git-prompt/gpchange.sh"
    alias gpthemes="bash $HOME/.bash-git-prompt/gpthemes.sh"
    source "$HOME/.bash-git-prompt/gitprompt.sh"
fi
```
To
```bash
if [ -f "$HOME/.bash-git-prompt/gitprompt.sh" ]; then
    GIT_PROMPT_THEME=fancy-white
    alias gpchange="bash $HOME/.bash-git-prompt/gpchange.sh"
    alias gpthemes="bash $HOME/.bash-git-prompt/gpthemes.sh"
    source "$HOME/.bash-git-prompt/gitprompt.sh"
fi
```
Then close and reopen your terminal.

### Changing themes method 2
In your terminal type gpchange and type name of the theme you would like to use. Then close and reopen your terminal. The following themes are currently provided and can be added to your ~/.bashrc file as shown above or using the gpchange command.

default\
fancy-orange\
fancy-white\
fancy-gold\
half-life\
hazard\
robby-russell\
this-way\
two-liner\
two-liner-time\
x-files\
x-files-time

### Display all themes in the terminal.
You can run the command gpthemes in your terminal in order to get a showcase of all available themes.

### Screenshot of the additional themes currently provided.

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-x-files.png" alt="x-files theme"/><br>Theme name: x-files
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-x-files-time.png" alt="x-files-time theme"/><br>Theme name: x-files-time
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-robby-russel.png" alt="robby-russel theme"/><br>Theme name: robby-russel
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-this-way.png" alt="this-way theme"/><br>Theme name: this way
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-two-liner.png" alt="two-liner theme"/><br>Theme name: two-liner
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-two-liner-time.png" alt="two-liner-time theme"/><br>Theme name: two-liner-time
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-fancy-white.png" alt="fancy-white theme"/><br>Theme name: fancy-white
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-fancy-gold.png" alt="fancy-gold theme"/><br>Theme name: fancy-gold
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-fancy-orange.png" alt="fancy-orange theme"/><br>Theme name: fancy-orange
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-half-life.png" alt="half-life theme"/><br>Theme name: half-life
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-theme-hazard.png" alt="hazard theme"/><br>Theme name: hazard
</p>

### Note on VS Code
In order to get this to work in the VS Code terminal you will have to adjust a few settings for the symbols to render correctly. Open "File -> Preferences -> Settings" then adjust the following.

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-vscode1.png" alt="vscode settings"/><br>Search for <b><i>Terminal Font Family</i></b> and insert the following <b><i>DejaVuSansMono Nerd Font</i></b>
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-vscode2.png" alt="vscode settings"/><br>Search for <b><i>Gpu Acceleration</i></b> and set it to <b><i>on</i></b>
</p>

<p align="left" width="100%">
<img src="https://git.x-files.dk/assets/bgp-vscode3.png" alt="vscode settings"/><br>Search for <b><i>Editor Font Family</i></b> and insert the following <b><i>'DejaVuSansMono Nerd Font', 'monospace', monospace</i></b>
</p>

### More guides
More guides can be found on [\[wiki.x-files.dk\]](https://wiki.x-files.dk)

### Last tested
January 8th 2025 on Ubuntu 24.04.
